Option Explicit On
Public Class Form1
    Inherits System.Windows.Forms.Form
    Dim wRtn As Short

    Dim wTotalBoards As Short
    Dim wBoardNo As Short
    Dim bSelCardID As Byte
    Dim dwDataNum As UInt32 = 40960
    Dim DoBuf(10240) As UInt32
    Dim DiBuf(40960) As UInt32
    Const pi = 3.14159265358979
    Const degree = pi / 180.0#
    Const maximum_fifo_loop_count = 2048

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim index As UInt16
        Dim bCardID As Byte

        '//Search Card
        wRtn = d64h_scan(wTotalBoards, 0)
        If (wRtn <> SUCCESS_NO_ERROR) Then
            MsgBox("Driver Initial Error!!Error Code:" + Str(wRtn))
            End
        End If

        For index = 0 To CUShort(wTotalBoards - 1)
            '//Get Card Information
            wRtn = d64h_cardinfo_get(index, bCardID)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("Get Card Information Err")
            End If

            Me.cbxSelBoard.Items.Add(Str(index) + ": &H" + Str(bCardID))

        Next

        tbxYup.Text = "&HFFFFFFFF"

        tbxYdown.Text = "&H0"

        For index = 0 To 10240 - 1
            'DoBuf(index) = CLng(327679.5 * Math.Sin((index Mod 1024) * 360 / 1024 * degree) + 327679.5)

            DoBuf(index) = CLng(2147483647.5 * Math.Sin((index Mod 1024) * 360 / 1024 * degree) + 2147483647.5)


        Next

    End Sub

    Private Sub cbxSelBoard_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxSelBoard.SelectedIndexChanged
        wBoardNo = CUShort(cbxSelBoard.SelectedIndex)
        '//Get Card Info
        wRtn = d64h_cardinfo_get(wBoardNo, bSelCardID)

        If (wRtn <> SUCCESS_NO_ERROR) Then
            MsgBox("Get Card Information Err")
        End If

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click

        Close()
    End Sub

    Private Sub btnActive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnActive.Click
        Dim i As Integer
        Dim dwBufLen As Long
        Dim Count As Long

        wBoardNo = CUShort(cbxSelBoard.SelectedIndex)
        dwDataNum = CLng(Me.tbxDataNum.Text)  '// (m_dwDISamples * sizeof(U32)/2 )

        If (btnActive.Text = "&ACTIVE") Then

            '//Config the Analog Input Setting

            btnActive.Text = "&STOP"
            btnExit.Enabled = False
            '//bDisplay = true;
            '//Open Card
            wRtn = d64h_open(bSelCardID)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("Open Card Err.Error Code:" + Str(wRtn))
            End If

            wRtn = d64h_di_available_memory(bSelCardID, dwBufLen)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("Memory error")
            End If

            If (dwDataNum * 4 > dwBufLen * 1024) Then

                MsgBox("Too much samples to be acquired")
                Exit Sub
            End If

            '//Config DO
            wRtn = d64h_do_config(bSelCardID, TRIG_SOURCE_INT_PACER, OREQ_DISABLE, OTRIG_HIGH)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("DO Config Error.Error Code =" + Str(wRtn))

            End If
            '//Config DI
            wRtn = d64h_di_config(bSelCardID, TRIG_SOURCE_INT_PACER, DI_NOWAITING, DI_TRIG_RISING, IREQ_FALLING)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("DI Config Error.Error Code =" + Str(wRtn))
                Exit Sub
            End If

            '// Enable DI double-buffer mode
            wRtn = d64h_di_async_dblbuf_mode(bSelCardID, DOUBLE_BUFFER_MODE_ENABLE)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                'cmdActive_Click
                MsgBox("Disable DO double-buffer mode Error.Error Code =" + Str(wRtn))
                Exit Sub
            End If

            '// Enable DO double-buffer mode
            wRtn = d64h_do_async_dblbuf_mode(bSelCardID, DOUBLE_BUFFER_MODE_ENABLE)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                'cmdActive_Click
                MsgBox("Disable DO double-buffer mode Error.Error Code =" + Str(wRtn))
                Exit Sub
            End If


            '// Write port
            wRtn = d64h_conti_writeport(bSelCardID, DoBuf(0), 10240, PARAMETER_IGNORED, 100000.0#, ASYNCH_OP)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("d64h_conti_pattern_write Error.Error Code =" + Str(wRtn))
                Exit Sub
            End If

            '//Read Port
            wRtn = d64h_conti_readport(bSelCardID, DiBuf(0), dwDataNum, CSng(Me.tbxSRate.Text) * 1000, ASYNCH_OP)
            If (wRtn <> SUCCESS_NO_ERROR) Then

                MsgBox("Conti Read Port Error.Error Code =" + Str(wRtn))
                Exit Sub

            End If
            Timer1.Enabled = True



        Else

            '//bDisplay = false;
            btnActive.Text = "&ACTIVE" '
            '//this.pbxDisplay_Paint(pbxDisplay, new PaintEventArgs(pbxDisplay.CreateGraphics(), Rectangle.Empty));                
            btnExit.Enabled = True
            Timer1.Enabled = False

            wRtn = d64h_di_async_clear(bSelCardID, Count)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                'cmdActive_Click
                MsgBox("DI Clear.Error Code =" + Str(wRtn))

            End If

            wRtn = d64h_do_async_clear(bSelCardID, Count)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                'cmdActive_Click
                MsgBox("DO Clear Error.Error Code =" + Str(wRtn))

            End If

            '//Close Card
            wRtn = d64h_close(bSelCardID)
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("Close Card Err.Error Code:" + Str(wRtn))
            End If


        End If


    End Sub

    '//Draw the Graphics for Analog Input Data
    Private Sub PlotData(ByVal g As Graphics)
        'float Yup = 20.0F, Ydown = -20.0F;
        Dim fScaleX As Single, fScaleY As Single
        Dim RedPen As New Pen(Color.Red)
        Dim BlackPen As New Pen(Color.Black)
        Dim PointArray(dwDataNum - 1) As PointF
        Dim LPointArray() As PointF
        Dim LBaseArray(1) As PointF
        Dim i As UInt16

        For i = PointArray.GetLowerBound(0) To PointArray.GetUpperBound(0)

            PointArray(i).X = i
            PointArray(i).Y = DiBuf(i)
        Next

        ReDim LPointArray(PointArray.GetUpperBound(0))

        fScaleX = pbxDisplay.Width / PointArray.Length
        fScaleY = CSng((pbxDisplay.Height * 0.97)) / (CSng(tbxYup.Text) - CSng(tbxYdown.Text))
        For i = PointArray.GetLowerBound(0) To PointArray.GetUpperBound(0)

            LPointArray(i).X = PointArray(i).X * fScaleX

            LPointArray(i).Y = ((CSng(tbxYup.Text) - PointArray(i).Y) * fScaleY)
        Next
        pbxDisplay.Refresh()
        g.DrawLines(RedPen, LPointArray)
        'pbxDisplay.Refresh();

        RedPen.Dispose()
        'g.Dispose();
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim gr As Graphics = pbxDisplay.CreateGraphics()
        Dim bHalfReady As Byte
        dwDataNum = CInt((tbxDataNum.Text) / 2.0)

        '//Check DI FIFO-half
        wRtn = d64h_di_async_dblbuf_halfready(bSelCardID, bHalfReady)
        If (wRtn <> SUCCESS_NO_ERROR) Then
            MsgBox("async_dblbuf_halfready Error|!Error Code:" + Str(wRtn))
            btnActive_Click(sender, e)
            Exit Sub
        End If

        '//Ready
        If (bHalfReady) Then

            wRtn = d64h_di_async_dblbuf_transfer(bSelCardID, DiBuf(0))
            If (wRtn <> SUCCESS_NO_ERROR) Then
                MsgBox("async_dblbuf_transfer|!Error Code:" + Str(wRtn))

                Exit Sub
            End If
            PlotData(gr)
                   
            Application.DoEvents()


        End If
        gr.Dispose()
    End Sub
End Class
