Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Module D64H
    '*********************************************************************************
    '      The Declare of i8092_dll.dll for I8092 Motion Module
    '*********************************************************************************
    '(VS 2005 code)

	Public Const D64H_MaxCards = 16
	
	Public Const INVALID_CARD_ID = &HFF

	Public Const PARAMETER_IGNORED = &HFFFF

	Public Const DOUBLE_BUFFER_MODE_ENABLE = &H01
	Public Const DOUBLE_BUFFER_MODE_DISABLE = &H00
		

	'---------Clock Mode	
	Public Const TRIG_SOURCE_INT_PACER = 1
	Public Const TRIG_SOURCE_EXT_STROBE = 2
  Public Const TRIG_SOURCE_HANDSHAKE = 3
			
	'---------Event type for the event message
	Public Const DIEnd = 0	
	Public Const DOEnd = 0
	Public Const DBEvent = 1
	Public Const TrigEvent = 2
					
	'---------Eevnt Operation
	Public Const ADD_NOTIFICATION = &H01
	Public Const REMOVE_NOTIFICATION = &H00
			
	'---------Input Mode
	Public Const DI_WAITING = &H02
	Public Const DI_NOWAITING = &H00
	
	Public Const DI_TRIG_RISING = &H04
	Public Const DI_TRIG_FALLING = &H00
	
	Public Const IREQ_RISING = &H08
	Public Const IREQ_FALLING = &H00
	
	'---------Output Mode
	Public Const OREQ_ENABLE = &H10
	Public Const OREQ_DISABLE = &H00
	
	Public Const OTRIG_HIGH = &H20
	Public Const OTRIG_LOW = &H00		

	'---------Synchronous Mode
	Public Const SYNCH_OP = &H01
	Public Const ASYNCH_OP = &H02
		
	'---------DI DO Status
	Public Const DI_OVERRUN_STATUS = &H01
	Public Const DO_UNDERRUN_STATUS = &H02


  'Error Codes
	Public Const SUCCESS_NO_ERROR = 0

  ' indicate the unsuccessful system DeviceIoControl
	Public Const ERROR_ROUTINE_FAIL_BASE = -100	
	Public Const ERROR_DEVICE_OPEN = -102
	Public Const ERROR_DEVICE_CLOSE = -103
	Public Const ERROR_DOUBLE_BUFFER_MODE = -104
	Public Const ERROR_DI_CONFIG = -105
	Public Const ERROR_DI_ASYNC_CLEAR = -106
	Public Const ERROR_DI_ASYNC_CHECK = -107
	Public Const ERROR_DI_ASYNC_HALF_READY = -108
	Public Const ERROR_DI_PIO_READ = -109
	Public Const ERROR_DO_CONFIG = -110
	Public Const ERROR_DO_ASYNC_CLEAR = -111
	Public Const ERROR_DO_ASYNC_CHECK = -112
	Public Const ERROR_DO_PIO_READ = -113
	Public Const ERROR_DO_PIO_WRITE = -114
	Public Const ERROR_DO_PIO_LINE_WRITE = -115
	Public Const ERROR_CONTINUE_DI_START = -116
	Public Const ERROR_CONTINUE_DO_START = -117
	Public Const ERROR_FIFO_STATUS_GET = -118
	Public Const ERROR_DO_EXT_TRIGLINE_WRITE = -119
	Public Const ERROR_DO_ASYNC_HALF_READY = -120
	Public Const ERROR_DIGITAL_FILTER_SET = -121
	Public Const ERROR_OREQ_WIDTH_SET = -122
			

  ' Parameters Error
	Public Const ERROR_INVALID_PARAMETER_BASE = -200
	Public Const ERROR_INVALID_CARD_ID = -201
	Public Const ERROR_INVALID_SCANNED_INDEX = -202
	Public Const ERROR_CARD_ID_DUPLICATED = -203	
	Public Const ERROR_INVILID_DOUBLE_BUFFER_MODE = -204
	Public Const ERROR_INVALID_PORT_LINE = -205
	Public Const ERROR_INVALID_TRIGGER_SOURCE = -206
	Public Const ERROR_INVALID_TRIGGER_ENABLE = -207
  Public Const ERROR_INVALID_TRIGGER_POLARITY = -208
	Public Const ERROR_INVALID_IREQ_POLARITY = -209
	Public Const ERROR_INVALID_OTRIG_LEVEL = -210
	Public Const ERROR_INVALID_OREG_ENABLE = -211
	Public Const ERROR_INVALID_DOUBLE_BUFFER_MODE = -212
	Public Const ERROR_INVALID_SYNCH_OP_MODE = -213
	Public Const ERROR_SAMPLE_COUNT_IS_ODD = -214
	Public Const ERROR_INVALID_DO_ITERATIONS = -215
	Public Const ERROR_INVALID_EVENT_ACTION = -216
	Public Const ERROR_INVALID_CALLBACK_ADDRESS = -217
	Public Const ERROR_INVALID_BUFFER_ADDRESS = -218
	Public Const ERROR_INVALID_PATTERN_SIZE = -219
	Public Const ERROR_INVALID_FILTER_SETTING = -220
	Public Const ERROR_INVALID_OREG_WIDTH = -221

  ' RunTime Error
	Public Const ERROR_RUNTIME_BASE = -300

	Public Const ERROR_NO_CARD_FOUND = -316
	Public Const ERROR_MEMORY_MAP = -317
	Public Const ERROR_MEMORY_UNMAP = -318
	Public Const ERROR_ACCESS_VIOLATION_DATA_COPY = -319
	Public Const ERROR_VARIABLE_PITCH_SET = -320
	Public Const ERROR_DI_EVENT_ATTACH = -321
	Public Const ERROR_DI_EVENT_DETACH = -322
	Public Const ERROR_DO_EVENT_ATTACH = -323
	Public Const ERROR_DO_EVENT_DETACH = -324
	Public Const ERROR_EVENT_CREATE_FAILED = -325
	Public Const ERROR_OVERLAP_EVENT_CREATE = -326
	
	Public Const ERROR_IOCTL_FAILED = -361
	Public Const ERROR_UNDEFINED_EXCEPTION = -362

  ' DIO RunTime Error
	Public Const ERROR_DIO_RUNTIME_BASE = -500
	Public Const ERROR_DEVICE_POWER_DOWN = -501
	Public Const ERROR_INVALID_MAPPED_ADDRESS = -502
	Public Const ERROR_BUFFER_NOT_ENOUGH = -503
	Public Const ERROR_DMA_NOT_AVAILABLE = -504
	Public Const ERROR_DMA_NOT_COMPLETE = -505
	Public Const ERROR_DMA_NOT_STARTED = -506
	Public Const ERROR_DMA_NOT_PAUSED = -507
	Public Const ERROR_DMA_IS_PAUSED = -508
	Public Const ERROR_DMA_IN_PROGRESS = -509
	Public Const ERROR_INVALID_SAMPLE_RATE = -510
	Public Const ERROR_SAMPLE_COUNT_TOO_LARGE = -511
	Public Const ERROR_SYNCH_OP_WITH_DOUBLE_BUFFER_MODE = -512
	Public Const ERROR_SYNCH_OP_WITH_ASYNC_CHECK = -513
	Public Const ERROR_UNSUPPORTED_SETTING = -514
	Public Const ERROR_PATTERN_OUT_WITH_DOUBLE_BUFFER_MODE = -515
	Public Const ERROR_PATTERN_OUT_IN_PROGRESS = -516

    Public Delegate Sub CallbackDelegate()
    '-------------------------------------------------------------------
    '  PCI-D64HU Function Declarations
    '-----------------------------------------------------------------
    <DllImport("D64HDLL.dll")> Function d64h_scan(ByRef pCardNum As Short, Optional ByRef pAvailCards As Byte = 0) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_cardinfo_get(ByVal ScannedIndex As UShort, ByRef pCardID As Byte) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_open(ByVal bCardID As Byte) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_close(ByVal bCardID As Byte) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_event_callback(ByVal bCardID As Byte, ByVal wEventEnable As UShort, ByVal wEventType As UShort, ByVal callbackAddr As CallbackDelegate) As Short
    End Function


    '-------------------------------------------------------------------
    ' DI related Routines
    '-------------------------------------------------------------------
    
    <DllImport("D64HDLL.dll")> Function d64h_di_config(ByVal bCardID As Byte, ByVal wTrigSource As UShort, ByVal wExtTrigEnable As UShort, ByVal wTrigPolarity As UShort, ByVal wI_REQ_Polarity As UShort) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_buffer_get(ByVal bCardID As Byte, ByRef pMemSize As UInteger, Optional ByRef pLowBufAddr As UInteger = 0, Optional ByRef pHighBufAddr As UInteger = 0) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_available_memory(ByVal bCardID As Byte, ByRef pMemSize As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_async_clear(ByVal bCardID As Byte, ByRef pAccessCount As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_async_check(ByVal bCardID As Byte, ByRef pStopped As Byte, ByRef pAccessCount As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_async_dblbuf_mode(ByVal bCardID As Byte, ByVal wDblBufEnable As UShort) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_async_dblbuf_halfready(ByVal bCardID As Byte, ByRef pHalfReady As Byte, Optional ByRef pBufIndex As Short = 0) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_async_dblbuf_transfer(ByVal bCardID As Byte, ByRef pBuffer As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_readport(ByVal bCardID As Byte, ByRef pValue As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_di_readline(ByVal bCardID As Byte, ByVal wLine As UShort, ByRef pValue As UShort) As Short
    End Function    
       
    <DllImport("D64HDLL.dll")> Function d64h_continue_readport(ByVal bCardID As Byte, ByRef pBuffer As UInteger, ByVal dwSampleCount As UInteger, ByRef pSampleRate As Double, ByVal wSyncMode As UShort) As Short
    End Function
                  
    <DllImport("D64HDLL.dll")> Function d64h_conti_di_status(ByVal bCardID As Byte, ByRef pStatus As UShort) As Short
    End Function        
                    

    '-------------------------------------------------------------------
    ' DO related Routines
    '-------------------------------------------------------------------
    
    <DllImport("D64HDLL.dll")> Function d64h_do_config(ByVal bCardID As Byte, ByVal wTrigSource As UShort, ByVal wO_REQ_Enable As UShort, ByVal wOutTrigHigh As UShort) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_buffer_get(ByVal bCardID As Byte, ByRef pMemSize As UInteger, Optional ByRef pLowBufAddr As UInteger = 0, Optional ByRef pHighBufAddr As UInteger = 0) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_available_memory(ByVal bCardID As Byte, ByRef pMemSize As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_async_clear(ByVal bCardID As Byte, ByRef pAccessCount As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_async_check(ByVal bCardID As Byte, ByRef pStopped As Byte, ByRef pAccessCount As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_async_dblbuf_mode(ByVal bCardID As Byte, ByVal wDblBufEnable As UShort) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_async_dblbuf_halfready(ByVal bCardID As Byte, ByRef pHalfReady As Byte, Optional ByRef pBufIndex As Short = 0) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_async_dblbuf_transfer(ByVal bCardID As Byte, ByRef pBuffer As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_readport(ByVal bCardID As Byte, ByRef pValue As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_readline(ByVal bCardID As Byte, ByVal wLine As UShort, ByRef pValue As UShort) As Short
    End Function    

    <DllImport("D64HDLL.dll")> Function d64h_do_writeport(ByVal bCardID As Byte, ByVal dwValue As UInteger) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_do_writeline(ByVal bCardID As Byte, ByVal wLine As UShort, ByVal wValue As UShort) As Short
    End Function    
               
    <DllImport("D64HDLL.dll")> Function d64h_continue_writeport(ByVal bCardID As Byte, ByRef pBuffer As UInteger, ByVal dwSampleCount As UInteger, ByVal wIterations As UShort, ByRef pSampleRate As Double, ByVal wSyncMode As UShort) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_continue_pattern_write(ByVal bCardID As Byte, ByRef pBuffer As UInteger, ByVal dwSampleCount As UInteger, ByRef pSampleRate As Double) As Short
    End Function
                      
    <DllImport("D64HDLL.dll")> Function d64h_conti_do_status(ByVal bCardID As Byte, ByRef pStatus As UShort) As Short
    End Function        
    
    <DllImport("D64HDLL.dll")> Function d64h_do_ext_trigline_write(ByVal bCardID As Byte, ByVal wValue As UShort) As Short
    End Function  
    
    <DllImport("D64HDLL.dll")> Function d64h_DI_filter_set(ByVal bCardID As Byte, ByVal wDIFilter As UShort) As Short
    End Function  
    
    <DllImport("D64HDLL.dll")> Function d64h_IREQ_filter_set(ByVal bCardID As Byte, ByVal wIREQFilter As UShort) As Short
    End Function  
    
    <DllImport("D64HDLL.dll")> Function d64h_OACK_filter_set(ByVal bCardID As Byte, ByVal wOACKFilter As UShort) As Short
    End Function  
    
    <DllImport("D64HDLL.dll")> Function d64h_ITRG_filter_set(ByVal bCardID As Byte, ByVal wITRGFilter As UShort) As Short
    End Function                  
        
    <DllImport("D64HDLL.dll")> Function d64h_OREQ_width_set(ByVal bCardID As Byte, ByVal wOREQWidth As UShort) As Short
    End Function                                 

    '-------------------------------------------------------------------
    ' Undocumented APIs
    '-------------------------------------------------------------------
    
    <DllImport("D64HDLL.dll")> Function d64h_conti_readport(ByVal bCardID As Byte, ByRef pBuffer As UInteger, ByVal dwSampleCount As UInteger, ByVal fSampleRate As Double, ByVal wSyncMode As UShort) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_conti_writeport(ByVal bCardID As Byte, ByRef pBuffer As UInteger, ByVal dwSampleCount As UInteger, ByVal wIterations As UShort, ByVal fSampleRate As Double, ByVal wSyncMode As UShort) As Short
    End Function

    <DllImport("D64HDLL.dll")> Function d64h_conti_pattern_write(ByVal bCardID As Byte, ByRef pBuffer As UInteger, ByVal dwSampleCount As UInteger, ByVal fSampleRate As Double) As Short
    End Function    
    
End Module